<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:49 JST 2014 -->
<TITLE>
Leader
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Leader";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/FollowerZooKeeperServer.html" title="class in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/Leader.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Leader.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper.server.quorum</FONT>
<BR>
Class Leader</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.server.quorum.Leader</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>Leader</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This class has the control logic for the Leader.
<P>

<P>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.XidRolloverException.html" title="class in org.apache.zookeeper.server.quorum">Leader.XidRolloverException</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#ACKEPOCH">ACKEPOCH</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This message is used by the follow to ack a proposed epoch.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#LEADERINFO">LEADERINFO</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This message is the first that a follower receives from the leader.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#PROPOSAL">PROPOSAL</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This message type is sent by a leader to propose a mutation.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#commit(long)">commit</A></B>(long&nbsp;zxid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Create a commit packet and send it to all the members of the quorum</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getEpoch()">getEpoch</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the current epoch of the leader.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getEpochToPropose(long, long)">getEpochToPropose</A></B>(long&nbsp;sid,
                  long&nbsp;lastAcceptedEpoch)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getForwardingFollowers()">getForwardingFollowers</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a copy of the current forwarding follower snapshot</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getLearners()">getLearners</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a copy of the current learner snapshot</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getNumPendingSyncs()">getNumPendingSyncs</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getObservingLearners()">getObservingLearners</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a copy of the current observer snapshot</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#getPacketType(int)">getPacketType</A></B>(int&nbsp;packetType)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get string representation of a given packet type</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#inform(org.apache.zookeeper.server.quorum.Leader.Proposal)">inform</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A>&nbsp;proposal)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Create an inform packet and send it to all observers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#processAck(long, long, java.net.SocketAddress)">processAck</A></B>(long&nbsp;sid,
           long&nbsp;zxid,
           java.net.SocketAddress&nbsp;followerAddr)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Keep a count of acks that are received by the leader for a particular
 proposal</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#processSync(org.apache.zookeeper.server.quorum.LearnerSyncRequest)">processSync</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerSyncRequest.html" title="class in org.apache.zookeeper.server.quorum">LearnerSyncRequest</A>&nbsp;r)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Process sync requests</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#propose(org.apache.zookeeper.server.Request)">propose</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/Request.html" title="class in org.apache.zookeeper.server">Request</A>&nbsp;request)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;create a proposal and send it out to all the members</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#sendSync(org.apache.zookeeper.server.quorum.LearnerSyncRequest)">sendSync</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerSyncRequest.html" title="class in org.apache.zookeeper.server.quorum">LearnerSyncRequest</A>&nbsp;r)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Sends a sync message to the appropriate server</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#startForwarding(org.apache.zookeeper.server.quorum.LearnerHandler, long)">startForwarding</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&nbsp;handler,
                long&nbsp;lastSeenZxid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;lets the leader know that a follower is capable of following and is done
 syncing</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#waitForEpochAck(long, org.apache.zookeeper.server.quorum.StateSummary)">waitForEpochAck</A></B>(long&nbsp;id,
                <A HREF="../../../../../org/apache/zookeeper/server/quorum/StateSummary.html" title="class in org.apache.zookeeper.server.quorum">StateSummary</A>&nbsp;ss)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html#waitForNewLeaderAck(long, long, org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType)">waitForNewLeaderAck</A></B>(long&nbsp;sid,
                    long&nbsp;zxid,
                    <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A>&nbsp;learnerType)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Process NEWLEADER ack of a given sid and wait until the leader receives
 sufficient acks.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="LEADERINFO"><!-- --></A><H3>
LEADERINFO</H3>
<PRE>
public static final int <B>LEADERINFO</B></PRE>
<DL>
<DD>This message is the first that a follower receives from the leader.
 It has the protocol version and the epoch of the leader.
<P>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.Leader.LEADERINFO">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="ACKEPOCH"><!-- --></A><H3>
ACKEPOCH</H3>
<PRE>
public static final int <B>ACKEPOCH</B></PRE>
<DL>
<DD>This message is used by the follow to ack a proposed epoch.
<P>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.Leader.ACKEPOCH">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="PROPOSAL"><!-- --></A><H3>
PROPOSAL</H3>
<PRE>
public static final int <B>PROPOSAL</B></PRE>
<DL>
<DD>This message type is sent by a leader to propose a mutation.
<P>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.Leader.PROPOSAL">Constant Field Values</A></DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getLearners()"><!-- --></A><H3>
getLearners</H3>
<PRE>
public java.util.List&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&gt; <B>getLearners</B>()</PRE>
<DL>
<DD>Returns a copy of the current learner snapshot
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getForwardingFollowers()"><!-- --></A><H3>
getForwardingFollowers</H3>
<PRE>
public java.util.List&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&gt; <B>getForwardingFollowers</B>()</PRE>
<DL>
<DD>Returns a copy of the current forwarding follower snapshot
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getObservingLearners()"><!-- --></A><H3>
getObservingLearners</H3>
<PRE>
public java.util.List&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&gt; <B>getObservingLearners</B>()</PRE>
<DL>
<DD>Returns a copy of the current observer snapshot
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getNumPendingSyncs()"><!-- --></A><H3>
getNumPendingSyncs</H3>
<PRE>
public int <B>getNumPendingSyncs</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="processAck(long, long, java.net.SocketAddress)"><!-- --></A><H3>
processAck</H3>
<PRE>
public void <B>processAck</B>(long&nbsp;sid,
                       long&nbsp;zxid,
                       java.net.SocketAddress&nbsp;followerAddr)</PRE>
<DL>
<DD>Keep a count of acks that are received by the leader for a particular
 proposal
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>zxid</CODE> - the zxid of the proposal sent out<DD><CODE>followerAddr</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="commit(long)"><!-- --></A><H3>
commit</H3>
<PRE>
public void <B>commit</B>(long&nbsp;zxid)</PRE>
<DL>
<DD>Create a commit packet and send it to all the members of the quorum
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>zxid</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="inform(org.apache.zookeeper.server.quorum.Leader.Proposal)"><!-- --></A><H3>
inform</H3>
<PRE>
public void <B>inform</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A>&nbsp;proposal)</PRE>
<DL>
<DD>Create an inform packet and send it to all observers.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>zxid</CODE> - <DD><CODE>proposal</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="getEpoch()"><!-- --></A><H3>
getEpoch</H3>
<PRE>
public long <B>getEpoch</B>()</PRE>
<DL>
<DD>Returns the current epoch of the leader.
<P>
<DD><DL>

<DT><B>Returns:</B><DD></DL>
</DD>
</DL>
<HR>

<A NAME="propose(org.apache.zookeeper.server.Request)"><!-- --></A><H3>
propose</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A> <B>propose</B>(<A HREF="../../../../../org/apache/zookeeper/server/Request.html" title="class in org.apache.zookeeper.server">Request</A>&nbsp;request)
                        throws <A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.XidRolloverException.html" title="class in org.apache.zookeeper.server.quorum">Leader.XidRolloverException</A></PRE>
<DL>
<DD>create a proposal and send it out to all the members
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>request</CODE> - 
<DT><B>Returns:</B><DD>the proposal that is queued to send to all the members
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.XidRolloverException.html" title="class in org.apache.zookeeper.server.quorum">Leader.XidRolloverException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="processSync(org.apache.zookeeper.server.quorum.LearnerSyncRequest)"><!-- --></A><H3>
processSync</H3>
<PRE>
public void <B>processSync</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerSyncRequest.html" title="class in org.apache.zookeeper.server.quorum">LearnerSyncRequest</A>&nbsp;r)</PRE>
<DL>
<DD>Process sync requests
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>r</CODE> - the request</DL>
</DD>
</DL>
<HR>

<A NAME="sendSync(org.apache.zookeeper.server.quorum.LearnerSyncRequest)"><!-- --></A><H3>
sendSync</H3>
<PRE>
public void <B>sendSync</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerSyncRequest.html" title="class in org.apache.zookeeper.server.quorum">LearnerSyncRequest</A>&nbsp;r)</PRE>
<DL>
<DD>Sends a sync message to the appropriate server
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>f</CODE> - <DD><CODE>r</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="startForwarding(org.apache.zookeeper.server.quorum.LearnerHandler, long)"><!-- --></A><H3>
startForwarding</H3>
<PRE>
public long <B>startForwarding</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/LearnerHandler.html" title="class in org.apache.zookeeper.server.quorum">LearnerHandler</A>&nbsp;handler,
                            long&nbsp;lastSeenZxid)</PRE>
<DL>
<DD>lets the leader know that a follower is capable of following and is done
 syncing
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>handler</CODE> - handler of the follower
<DT><B>Returns:</B><DD>last proposed zxid</DL>
</DD>
</DL>
<HR>

<A NAME="getEpochToPropose(long, long)"><!-- --></A><H3>
getEpochToPropose</H3>
<PRE>
public long <B>getEpochToPropose</B>(long&nbsp;sid,
                              long&nbsp;lastAcceptedEpoch)
                       throws java.lang.InterruptedException,
                              java.io.IOException</PRE>
<DL>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="waitForEpochAck(long, org.apache.zookeeper.server.quorum.StateSummary)"><!-- --></A><H3>
waitForEpochAck</H3>
<PRE>
public void <B>waitForEpochAck</B>(long&nbsp;id,
                            <A HREF="../../../../../org/apache/zookeeper/server/quorum/StateSummary.html" title="class in org.apache.zookeeper.server.quorum">StateSummary</A>&nbsp;ss)
                     throws java.io.IOException,
                            java.lang.InterruptedException</PRE>
<DL>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="waitForNewLeaderAck(long, long, org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType)"><!-- --></A><H3>
waitForNewLeaderAck</H3>
<PRE>
public void <B>waitForNewLeaderAck</B>(long&nbsp;sid,
                                long&nbsp;zxid,
                                <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A>&nbsp;learnerType)
                         throws java.lang.InterruptedException</PRE>
<DL>
<DD>Process NEWLEADER ack of a given sid and wait until the leader receives
 sufficient acks.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>sid</CODE> - <DD><CODE>learnerType</CODE> - 
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="getPacketType(int)"><!-- --></A><H3>
getPacketType</H3>
<PRE>
public static java.lang.String <B>getPacketType</B>(int&nbsp;packetType)</PRE>
<DL>
<DD>Get string representation of a given packet type
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>packetType</CODE> - 
<DT><B>Returns:</B><DD>string representing the packet type</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/FollowerZooKeeperServer.html" title="class in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/Leader.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Leader.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
